#!/bin/sh

export DUPLICACY_B2_ID=003f84b02198d880000000006
export DUPLICACY_B2_KEY=K003g9u1j3xTuK8LIETvYd8sEKhgA30
B2_BUCKET=test123-duplicacy

set -eux

echo "==== PREPARE"

# prepare workspace
rm -rf /tmp/break-duplicacy
mkdir -p /tmp/break-duplicacy
cd /tmp/break-duplicacy

# prepare files
mkdir bak
dd if=/dev/urandom of=fileA bs=1M count=10
dd if=/dev/urandom of=fileB bs=1M count=30   # should take ~30s to upload
dd if=/dev/urandom of=fileC bs=1M count=100  # should take ~90s to upload
cd bak

# init
duplicacy init test1 b2://$B2_BUCKET

# backup 0.1
mv -f ../fileA .
duplicacy backup

# backup 0.2
echo asdf > asdf
mv -f fileA ..
duplicacy backup

echo "==== RUN"

# now in parallel two backups and prune

# backup 1
rm -rf asdf
mv -f ../fileB .
time duplicacy backup &
bak1pid=$!

# backup 2
sleep 5
mv -f fileB ..
mv -f ../fileA ../fileC .
time duplicacy backup &
bak2pid=$!

# prune
sleep 5
duplicacy prune -r 1

# at this point prune should mark fileA as fossil and
# backup 1 should finish but backup 2 not yet
wait $bak1pid

# prune again
duplicacy prune

# at this point prune should delete fileA completely and
# backup 2 should finish
wait $bak2pid

# check backup is corrupted
duplicacy check -a || true
duplicacy cat fileA >/dev/null || true

# remove cache
rm -rf .duplicacy/cache
duplicacy check -a || true
duplicacy cat fileA >/dev/null || true

# clone freshly from backblaze
cd ..
mkdir fresh
cd fresh
duplicacy init test2 b2://$B2_BUCKET
duplicacy check -a || true
